Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO.Ports


Friend Class frmMain
	Inherits System.Windows.Forms.Form
	'*********************************************************************************
    '   ICS USB Keyboard Program                                   Revised 04-17-2014
	'
    '   ICS USB Keyboard Program is an interactive Serial Control program that
    '   demonstrates how to control ICS's products that use the Microsoft COM Port
    '   Drive from a Visual Basic program.
	'
    '   Copyright ICS Electronics 2010-2014
	'********************************************************************************
    '   04-04-12    Changed Serial keyboard to USB Keyboard
    '   01-10-14    Ported over to VB.NET 2010.
    '   04-05-14    Corrected COM port handling for 9009

    Dim LastOutStr As String
    Dim Settings As String = "115200,N,8,1"
    ' Dim Settings1 As String = "9600,N,8,1"
    '"2400,N,8,1"
    '"4800,N,8,1"
    '"9600,N,8,1"
    '"19200,N,8,1"
    '"38400,N,8,1"
    'Dim MSComm2 As MSComm
    'Dim MSComm1 As MSCommLib.MSComm

    Dim OutStr As String
    Dim NL As String = Chr(13) & Chr(10)
    Public IDNTestFlg As Integer = 0
    Public LpCount As Integer = 0
    Public CMDloopFlg As Integer = 0
    'Public MSComm1 As MSCommLib.MSComm = New MSCommLib.MSComm
    Public MSComm1 As System.IO.Ports.SerialPort = New System.IO.Ports.SerialPort

    Dim Rev As String = "Revised S10 4-17-2014"

	
    Sub Tdelay(ByRef delaytime As Double)
        Try
            Dim starttime As Double
            starttime = VB.Timer()
            Do Until VB.Timer() >= (starttime + delaytime)
            Loop
        Catch ex As Exception
            MsgBox("Tdelay Error =" & ex.Message)
        End Try
    End Sub
	
	Private Sub cmdCLS_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCLS.Click
        Try
            combCmd.Text = "*CLS"
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub
	
	Private Sub cmdCmdtst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCmdtst.Click
        Try
            If combCmd.Text = "" Then
                Beep()
                txtResults.Text = "No command specified.  Enter a command before starting the Command Loop"
            Else
                CMDloopFlg = 1
                Timer1.Enabled = True
            End If
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub
	
	Private Sub cmdCmdtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCmdtstoff.Click
        Try
            CMDloopFlg = LpCount = 0
            txtCount.Visible = False
            lblCount.Visible = False
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub
	
	Sub cmdE_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdE.Click
        Try
            '*KC* check that port is open maybe?
            OutStr = Chr(5)
            MSComm1.Write(OutStr)
            txtResults.Text = "CNTL-E sent"
        Catch ex As Exception
            MsgBox("Cntl-E Error =" & ex.Message)
        End Try
    End Sub
	
	Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
        Try
            If MSComm1.IsOpen = True Then
                MSComm1.Close()            'Close the serial port.
            End If
            End
        Catch ex As Exception
            MsgBox("Exit-closing COM Port Error =" & ex.Message)
        End Try
    End Sub
	
	Sub cmdF_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdF.Click
        Try
            '*KC* check that port is open maybe?
            OutStr = Chr(6)
            MSComm1.Write(OutStr)
            txtResults.Text = "CNTL-F sent"
        Catch ex As Exception
            MsgBox("Cntl-F Error =" & ex.Message)
        End Try
    End Sub
	
	Private Sub cmdIDNTst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIDNTst.Click
        Try
            combCmd.Text = "*idn?"
            IDNTestFlg = 1
            Timer1.Enabled = True
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub
	
	Private Sub cmdIDNtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdIDNtstoff.Click
        Try
            IDNTestFlg = LpCount = 0
            txtCount.Visible = False
            lblCount.Visible = False
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub
	
    Private Sub cmdRead_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRead.Click
        Dim buffer As String = ""
        Dim Term As String = ""
        Dim Rdcount As Short = 0
        Dim LN As Short
        Dim L As Short
        Dim N As Short
        Dim rdg As String

            txtError.Visible = False
        'Try
        If ckLF.CheckState = CheckState.Checked Then
            Term = Chr(10)
        Else
            If ckCR.CheckState = CheckState.Checked Then
                Term = Chr(13)                '*KC* -look at this not a lf & CR but one or the other
            End If
        End If

        Do  'read to terminator or timeout
            System.Windows.Forms.Application.DoEvents()
            If MSComm1.BytesToRead() Then
                'buffer = buffer & MSComm1.ReadLine()
                buffer = buffer & MSComm1.ReadExisting
            End If
            Rdcount = Rdcount + 1
        Loop Until (InStr(buffer, Term)) Or (Rdcount > 3000)


        If ckPrompt.Checked = True Then
            Rdcount = 0
            Do                                           'read again to get the prompt
                If MSComm1.BytesToRead() Then
                    'buffer = buffer & MSComm1.ReadLine()
                    buffer = buffer & MSComm1.ReadExisting
                End If
                Rdcount = Rdcount + 1
            Loop Until (InStr(buffer$, ">")) Or (Rdcount > 1000)
            If Rdcount > 1000 Then
                txtError.Text = "Prompt not found. Uncheck Next Msg Prompt box if communicating with a non-ICS device"
                txtError.Visible = True
                Beep()
            End If
        End If
        Call Tdelay(0.02)

        'Do  'get last linefeed if missed
        'System.Windows.Forms.Application.DoEvents()
        'buffer = buffer & MSComm1.ReadLine()
        'Rdcount = Rdcount + 1
        'Loop Until (MSComm1.ReadBufferSize = 0) Or (Rdcount > 1000)

        If Len(buffer) = 0 Then
            txtResults.Text = "Rx buffer empty"
        Else
            rdg = ""
            L = Len(buffer)                     'original buffer length
            If ckDispAll.CheckState = CheckState.Unchecked Then        'truncates string to first terminator
                If InStr(buffer, Chr(13)) <> 0 Then
                    rdg = VB.Left(buffer, InStr(buffer, Chr(13)) - 1)
                ElseIf InStr(buffer, vbLf) <> 0 Then
                    rdg = VB.Left(buffer, InStr(buffer, Chr(10)) - 1)
                End If
            Else                                    'display all characters substituting <cr> and <lf>
                Do Until InStr(buffer, Chr(13)) = 0     'replace CR loop
                    LN = Len(buffer)
                    N = InStr(buffer, Chr(13))
                    If N = 1 Then
                        buffer = "<cr>" + VB.Right(buffer, LN - N)      'replace first char
                    Else
                        buffer = VB.Left(buffer, N - 1) + "<cr>" + VB.Right(buffer, LN - N) 'replace any other char
                    End If
                Loop

                Do Until InStr(buffer, Chr(10)) = 0     'replace LF loop
                    LN = Len(buffer)
                    N = InStr(buffer, Chr(10))
                    If N = 1 Then
                        buffer = "<lf>" + VB.Right(buffer, LN - N)      'replace first char
                    Else
                        buffer = VB.Left(buffer, N - 1) + "<lf>" + VB.Right(buffer, LN - N) 'replace any other char
                    End If
                Loop
                rdg = buffer
            End If
            txtResults.Text = rdg
            If ckByteCnt.CheckState = CheckState.Checked Then           'display count
                txtResults.Text = txtResults.Text & NL & "Count = " & Str$(L)
            End If
        End If
        ' Catch ex As Exception
        'MsgBox("Read Error =" & ex.Message)
        ' End Try
    End Sub

    Private Sub cmdRST_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRST.Click
        Try
            combCmd.Text = "*RST"
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        Catch ex As Exception
            MsgBox("RST Error =" & ex.Message)
        End Try
    End Sub

    Sub cmdSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSend.Click
        Try
            txtError.Visible = False
            If MSComm1.BytesToRead() Then
                MSComm1.DiscardInBuffer()       'clear input buffer
            End If
        Catch ex As Exception
            MsgBox("Send Clear Buffer-bytes to read error =" & ex.Message)
        End Try

        If Len(combCmd.Text) = 0 And Len(LastOutStr) = 0 Then       'if nothing to send
            Beep()
            txtError.Text = "Nothing to send"
            txtError.Visible = True
        Else
            LastOutStr = combCmd.Text 'save msg
            OutStr = combCmd.Text
            If ckCR.CheckState = CheckState.Checked Then OutStr = OutStr & Chr(13)
            If ckLF.CheckState = CheckState.Checked Then OutStr = OutStr & Chr(10)
            Try
                'MSComm1.Write(String.Format("{0}", OutStr.ToString)) 'output string
                MSComm1.Write(OutStr.ToString)                     'output string
            Catch ex As Exception
                MsgBox("Send output error=" & ex.Message)
            End Try

            Try
                If (ckAuto.CheckState = CheckState.Checked) And (InStr(OutStr, "?") <> 0) Or (ckRead.CheckState = CheckState.Checked) Then
                    Call cmdRead_Click(cmdRead, New System.EventArgs()) 'read query response
                Else
                    txtResults.Text = "Sent " & OutStr
                End If
            Catch ex As Exception
                MsgBox("Send-Call read error=" & ex.Message)
            End Try
        End If
        
    End Sub

    Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        txtRev.Text = Rev
        combCmd.Items.Insert(0, "*esr?")
        combCmd.Items.Insert(1, "*idn?")
        combCmd.Items.Insert(2, "*stb?")
        Timer1.Enabled = False
        opt3.Checked = True
        cmdE.Enabled = False
        cmdF.Enabled = False
        cmdRST.Enabled = False
        cmdCLS.Enabled = False
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIDNTst.Enabled = False
        cmdIDNtstoff.Enabled = False
        cmdCmdtst.Enabled = False
        cmdCmdtstoff.Enabled = False

    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Try
            If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
                txtCount.Visible = False
                LpCount = 0
            ElseIf IDNTestFlg = 1 Then 'IDN read loop
                combCmd.Text = "*IDN?"
                Call cmdSend_Click(cmdSend, New System.EventArgs())
                txtCount.Visible = True
                lblCount.Visible = True
                LpCount = LpCount + 1
                txtCount.Text = LpCount
            ElseIf CMDloopFlg = 1 Then 'loop using the string in the combCmd.text
                If combCmd.Text = "" Then
                    Beep()
                    txtError.Text = "Command box empty"
                    txtError.Visible = True
                Else
                    Call cmdSend_Click(cmdSend, New System.EventArgs())
                    txtCount.Visible = True
                    lblCount.Visible = True
                    LpCount = LpCount + 1
                    txtCount.Text = LpCount
                End If
            End If

        Catch ex As Exception
            MsgBox("Timer1 Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdInit.Click
        Try
            If MSComm1.IsOpen() = True Then
                MSComm1.Close()
            End If
            ' Allow the user to set the appropriate properties.
            MSComm1.PortName = CB_COM.Text
            MSComm1.BaudRate = 115200
            MSComm1.Parity = Parity.None
            MSComm1.DataBits = 8
            MSComm1.StopBits = StopBits.One
            MSComm1.Handshake = Handshake.None
            MSComm1.ReadTimeout = 5000
            MSComm1.WriteTimeout = 500
            'MSComm1.InputLen = 0
            MSComm1.RtsEnable = True
            MSComm1.DtrEnable = True

            'note add a try loop incase a port is already opened.
            MSComm1.Open()
            cmdRST.Enabled = True
            cmdE.Enabled = True
            cmdF.Enabled = True
            cmdRST.Enabled = True
            cmdCLS.Enabled = True
            cmdSend.Enabled = True
            cmdIDNTst.Enabled = True
            cmdCmdtst.Enabled = True
            cmdIDNtstoff.Enabled = True
            cmdCmdtstoff.Enabled = True
            txtResults.Text = "COM port opened"

        Catch ex As Exception
            MsgBox("cmdInit Error =" & ex.Message)
        End Try
    End Sub

   
    Private Sub combCmd_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles combCmd.KeyPress
        Try
            If e.KeyChar = Chr(13) Then
                Call cmdSend_Click(cmdSend, New System.EventArgs())
            End If
        Catch ex As Exception
            MsgBox("Device Command Window keypress Error =" & ex.Message)
        End Try
    End Sub

    Private Sub opt0_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt0.CheckedChanged
        Timer1.Interval = 100 'sets timer interval in ms
        opt1.Checked = False
        opt2.Checked = False
        opt3.Checked = False
        opt4.Checked = False
    End Sub

    Private Sub opt1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt1.CheckedChanged
        Timer1.Interval = 200 'sets timer interval in ms
        opt0.Checked = False
        opt2.Checked = False
        opt3.Checked = False
        opt4.Checked = False
    End Sub

    Private Sub opt2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt2.CheckedChanged
        Timer1.Interval = 300 'sets timer interval in ms
        opt0.Checked = False
        opt1.Checked = False
        opt3.Checked = False
        opt4.Checked = False
    End Sub

    Private Sub opt3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt3.CheckedChanged
        Timer1.Interval = 500 'sets timer interval in ms
        opt0.Checked = False
        opt1.Checked = False
        opt2.Checked = False
        opt4.Checked = False
    End Sub

    Private Sub opt4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt4.CheckedChanged
        Timer1.Interval = 1000 'sets timer interval in ms
        opt0.Checked = False
        opt1.Checked = False
        opt2.Checked = False
        opt3.Checked = False
    End Sub
End Class